﻿using System;
using System.Linq;
using Microsoft.Commerce.Common.MessageBuilders;
using Microsoft.Commerce.Contracts;
using Microsoft.Commerce.Contracts.Messages;
using Microsoft.CommerceServer.Catalog;
using Microsoft.CommerceServer.Runtime;


namespace ASPNet3346
{
    public partial class GetACatalog : System.Web.UI.Page
    {
        
        protected void btnCS2007_Click(object sender, EventArgs e)
        {

            ProductCatalog productCatalog = (ProductCatalog)CommerceContext.Current.CatalogSystem.GetCatalog("Adventure Works Catalog", "en-US");
            DisplayHelper.DisplayValue("Catalog ID", productCatalog.Name, Response);
            DisplayHelper.DisplayValue("IdentifyingProductProperty", productCatalog.IdentifyingProductProperty, Response);

        }
      

        protected void btnCS2009_Click(object sender, EventArgs e)
        {
            var catalogQuery = new CommerceQuery<CommerceEntity>("Catalog");

            //TODO Theme Microsoft Multi-Channel Commerce Foundation RequestContext object will BindingContainert he user locale information used to get the catalogs in the appropriate language. If the language in the RequestContext is NotFiniteNumberExceptionc urrently supported, the _Defaultl anguage for thec atalog(s) willb e used.
            //catalogQuery.SearchCriteria.Model.Properties["language"] = "en-US";
            catalogQuery.SearchCriteria.Model.Id = "Adventure Works Catalog";




            CommerceResponse response = CommerceFoundationServiceAgent.Execute(catalogQuery);

            // Handle Responses
            CommerceQueryOperationResponse queryResponse = response.OperationResponses.Single() as CommerceQueryOperationResponse;
            CommerceEntity productCatalog = queryResponse.CommerceEntities.SingleOrDefault();

            DisplayHelper.DisplayValue("Catalog ID", productCatalog.Id, Response);
            DisplayHelper.DisplayValue("IdentifyingProductProperty", productCatalog.Properties["IdentifyingProductProperty"], Response);
            
        }



    }
}
